#include <Wire.h> // biblioteka I2C
#include <RtcDS3231.h> // RTC - DS3231
#include <OneWire.h>
#include <DallasTemperature.h>
#include <SoftwareSerial.h>
SoftwareSerial OpenLog(2, 3);
RtcDS3231<TwoWire> zegar(Wire); //obiekt zegar RTC 
OneWire obiektOneWire(A0); //wykorzystujemy pin A0
DallasTemperature czujniki(&obiektOneWire);
int liczbaCzujnikow; DeviceAddress tmpAdresyCzujnikow;

void setup(void)   { zegar.Begin(); //inicjalizacja
 Serial.begin(9600);  czujniki.begin(); OpenLog.begin(9600);
 liczbaCzujnikow = czujniki.getDeviceCount(); 
 RtcDateTime czasKompilacji = RtcDateTime(__DATE__, __TIME__);
 if (!zegar.IsDateTimeValid()) zegar.SetDateTime(czasKompilacji);
 if (!zegar.GetIsRunning())   zegar.SetIsRunning(true); 
 RtcDateTime czasAktualny = zegar.GetDateTime();  
 if(czasAktualny<czasKompilacji) zegar.SetDateTime(czasKompilacji); 
 Serial.print("inicjalizacja karty SD..."); }
//' if (!SD.begin(10)){ //wykorzystujemy pin 10 jako SS
//  Serial.println("Blad karty SD!"); while (1);}
//  Serial.println("Inicjalizacja SD prawidłowa."); }
 
void loop(void)  { if (digitalRead(A2) == LOW) 
 {Serial.println("Rejestracja wstrzymana");
  delay(3000);   }   else   {
  RtcDateTime czasAktualny = zegar.GetDateTime();
  czujniki.requestTemperatures(); 
  String mojRekord = ""; //obiekt typu String
//  printDateTime(czasAktualny);  Serial.print(" ");
  mojRekord += String(czasAktualny.Year());
  mojRekord += '-';
  mojRekord += String(czasAktualny.Month());
  mojRekord += '-';
  mojRekord += String(czasAktualny.Day());
  mojRekord += 'T'; // wstawiamy literkę T
// mojRekord += ' '; //opcja - spacja zamiast litery T 
  mojRekord += String(czasAktualny.Hour());
  mojRekord += ':';
  mojRekord += String(czasAktualny.Minute());
  mojRekord += ':';
  mojRekord += String(czasAktualny.Second());
  mojRekord += ',';
  for(int i=0;i<liczbaCzujnikow; i++)   { 
  czujniki.getAddress(tmpAdresyCzujnikow, i);
  float tempC = czujniki.getTempC(tmpAdresyCzujnikow);   
  Serial.print("Czujnik ");   Serial.print(i,DEC);
  Serial.print(": "); Serial.print(tempC);
  Serial.print("\xC2\xB0"); Serial.print("C; "); 
  mojRekord += String(tempC);
  mojRekord += ","; } //koniec odpytywania czujników
//mojRekord += ";"; //można od razu wstawić średniki
  Serial.println(); Serial.println("Na karcie SD zapiszemy: ");
  Serial.println(mojRekord);
  OpenLog.println(mojRekord); delay(1000); } }
